package me.goodandevil.skyblock.api.event.island;

import org.bukkit.entity.Player;
import org.bukkit.event.HandlerList;

import me.goodandevil.skyblock.api.island.Island;
import me.goodandevil.skyblock.api.island.IslandUpgrade;

public class IslandUpgradeEvent extends IslandEvent {

	private static final HandlerList HANDLERS = new HandlerList();

	private final Player player;
	private IslandUpgrade upgrade;

	public IslandUpgradeEvent(Island island, Player player, IslandUpgrade upgrade) {
		super(island);
		this.player = player;
	}

	public Player getPlayer() {
		return player;
	}

	public IslandUpgrade getUpgrade() {
		return upgrade;
	}

	@Override
	public HandlerList getHandlers() {
		return HANDLERS;
	}

	public static HandlerList getHandlerList() {
		return HANDLERS;
	}
}
